﻿using Newtonsoft.Json.Linq;
using PolymorphicDataBindingCore.Models;
using System;

namespace PolymorphicDataBindingCore.Convertors
{
    public class PersonJsonConverter : JsonCreationConverter<Person>
    {
        protected override Person Create(Type objectType, JObject jObject)
        {
            if (jObject == null) throw new ArgumentNullException("jObject");

            if (jObject["schoolName"] != null)
            {
                return new Student();
            }
            else if (jObject["hospitalName"] != null)
            {
                return new Doctor();
            }
            else
            {
                return new Person();
            }
        }
    }
}